"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Clusterer = void 0;

var _react = _interopRequireWildcard(require("react"));

var _reactNativeClusterer = _interopRequireDefault(require("react-native-clusterer"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

// @ts-ignore TODO: typefix
const Clusterer = /*#__PURE__*/(0, _react.memo)(_ref => {
  let {
    data,
    options,
    region,
    mapDimensions,
    renderItem
  } = _ref;
  const [markers, setMarkers] = (0, _react.useState)([]);
  const supercluster = (0, _react.useMemo)(() => new _reactNativeClusterer.default(options).load(data), [options, data]);
  (0, _react.useEffect)(() => {
    const result = supercluster.getClustersFromRegion(region, mapDimensions);
    setMarkers(result.map(c => {
      var _c$properties;

      const cid = c === null || c === void 0 ? void 0 : (_c$properties = c.properties) === null || _c$properties === void 0 ? void 0 : _c$properties.cluster_id;
      if (!cid) return c;

      const getClusterExpansionRegion = () => supercluster.expandCluster(cid);

      return { ...c,
        properties: { ...c.properties,
          getClusterExpansionRegion
        }
      };
    }));
  }, [data, region, mapDimensions, supercluster]);
  (0, _react.useEffect)(() => {
    return () => {
      supercluster.destroy();
    };
  }, []);
  return /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, markers.map(c => renderItem(c)));
}, (prevProps, nextProps) => {
  var _prevProps$options, _nextProps$options, _prevProps$options2, _nextProps$options2, _prevProps$options3, _nextProps$options3, _prevProps$options4, _nextProps$options4, _prevProps$options5, _nextProps$options5;

  return (//only if number of points has changed
    prevProps.data.length === nextProps.data.length && // options
    (prevProps === null || prevProps === void 0 ? void 0 : (_prevProps$options = prevProps.options) === null || _prevProps$options === void 0 ? void 0 : _prevProps$options.extent) === (nextProps === null || nextProps === void 0 ? void 0 : (_nextProps$options = nextProps.options) === null || _nextProps$options === void 0 ? void 0 : _nextProps$options.extent) && (prevProps === null || prevProps === void 0 ? void 0 : (_prevProps$options2 = prevProps.options) === null || _prevProps$options2 === void 0 ? void 0 : _prevProps$options2.maxZoom) === (nextProps === null || nextProps === void 0 ? void 0 : (_nextProps$options2 = nextProps.options) === null || _nextProps$options2 === void 0 ? void 0 : _nextProps$options2.maxZoom) && (prevProps === null || prevProps === void 0 ? void 0 : (_prevProps$options3 = prevProps.options) === null || _prevProps$options3 === void 0 ? void 0 : _prevProps$options3.minZoom) === (nextProps === null || nextProps === void 0 ? void 0 : (_nextProps$options3 = nextProps.options) === null || _nextProps$options3 === void 0 ? void 0 : _nextProps$options3.minZoom) && (prevProps === null || prevProps === void 0 ? void 0 : (_prevProps$options4 = prevProps.options) === null || _prevProps$options4 === void 0 ? void 0 : _prevProps$options4.minPoints) === (nextProps === null || nextProps === void 0 ? void 0 : (_nextProps$options4 = nextProps.options) === null || _nextProps$options4 === void 0 ? void 0 : _nextProps$options4.minPoints) && (prevProps === null || prevProps === void 0 ? void 0 : (_prevProps$options5 = prevProps.options) === null || _prevProps$options5 === void 0 ? void 0 : _prevProps$options5.radius) === (nextProps === null || nextProps === void 0 ? void 0 : (_nextProps$options5 = nextProps.options) === null || _nextProps$options5 === void 0 ? void 0 : _nextProps$options5.radius) && // region
    prevProps.region.latitude === nextProps.region.latitude && prevProps.region.longitude === nextProps.region.longitude && prevProps.region.latitudeDelta === nextProps.region.latitudeDelta && prevProps.region.longitudeDelta === nextProps.region.longitudeDelta && // mapDimensions
    prevProps.mapDimensions.width === nextProps.mapDimensions.width && prevProps.mapDimensions.height === nextProps.mapDimensions.height
  );
});
exports.Clusterer = Clusterer;
//# sourceMappingURL=Clusterer.js.map