import React, { memo, useEffect, useMemo, useState } from 'react';
import SuperclusterClass from 'react-native-clusterer';
// @ts-ignore TODO: typefix
export const Clusterer = /*#__PURE__*/memo(_ref => {
  let {
    data,
    options,
    region,
    mapDimensions,
    renderItem
  } = _ref;
  const [markers, setMarkers] = useState([]);
  const supercluster = useMemo(() => new SuperclusterClass(options).load(data), [options, data]);
  useEffect(() => {
    const result = supercluster.getClustersFromRegion(region, mapDimensions);
    setMarkers(result.map(c => {
      var _c$properties;

      const cid = c === null || c === void 0 ? void 0 : (_c$properties = c.properties) === null || _c$properties === void 0 ? void 0 : _c$properties.cluster_id;
      if (!cid) return c;

      const getClusterExpansionRegion = () => supercluster.expandCluster(cid);

      return { ...c,
        properties: { ...c.properties,
          getClusterExpansionRegion
        }
      };
    }));
  }, [data, region, mapDimensions, supercluster]);
  useEffect(() => {
    return () => {
      supercluster.destroy();
    };
  }, []);
  return /*#__PURE__*/React.createElement(React.Fragment, null, markers.map(c => renderItem(c)));
}, (prevProps, nextProps) => {
  var _prevProps$options, _nextProps$options, _prevProps$options2, _nextProps$options2, _prevProps$options3, _nextProps$options3, _prevProps$options4, _nextProps$options4, _prevProps$options5, _nextProps$options5;

  return (//only if number of points has changed
    prevProps.data.length === nextProps.data.length && // options
    (prevProps === null || prevProps === void 0 ? void 0 : (_prevProps$options = prevProps.options) === null || _prevProps$options === void 0 ? void 0 : _prevProps$options.extent) === (nextProps === null || nextProps === void 0 ? void 0 : (_nextProps$options = nextProps.options) === null || _nextProps$options === void 0 ? void 0 : _nextProps$options.extent) && (prevProps === null || prevProps === void 0 ? void 0 : (_prevProps$options2 = prevProps.options) === null || _prevProps$options2 === void 0 ? void 0 : _prevProps$options2.maxZoom) === (nextProps === null || nextProps === void 0 ? void 0 : (_nextProps$options2 = nextProps.options) === null || _nextProps$options2 === void 0 ? void 0 : _nextProps$options2.maxZoom) && (prevProps === null || prevProps === void 0 ? void 0 : (_prevProps$options3 = prevProps.options) === null || _prevProps$options3 === void 0 ? void 0 : _prevProps$options3.minZoom) === (nextProps === null || nextProps === void 0 ? void 0 : (_nextProps$options3 = nextProps.options) === null || _nextProps$options3 === void 0 ? void 0 : _nextProps$options3.minZoom) && (prevProps === null || prevProps === void 0 ? void 0 : (_prevProps$options4 = prevProps.options) === null || _prevProps$options4 === void 0 ? void 0 : _prevProps$options4.minPoints) === (nextProps === null || nextProps === void 0 ? void 0 : (_nextProps$options4 = nextProps.options) === null || _nextProps$options4 === void 0 ? void 0 : _nextProps$options4.minPoints) && (prevProps === null || prevProps === void 0 ? void 0 : (_prevProps$options5 = prevProps.options) === null || _prevProps$options5 === void 0 ? void 0 : _prevProps$options5.radius) === (nextProps === null || nextProps === void 0 ? void 0 : (_nextProps$options5 = nextProps.options) === null || _nextProps$options5 === void 0 ? void 0 : _nextProps$options5.radius) && // region
    prevProps.region.latitude === nextProps.region.latitude && prevProps.region.longitude === nextProps.region.longitude && prevProps.region.latitudeDelta === nextProps.region.latitudeDelta && prevProps.region.longitudeDelta === nextProps.region.longitudeDelta && // mapDimensions
    prevProps.mapDimensions.width === nextProps.mapDimensions.width && prevProps.mapDimensions.height === nextProps.mapDimensions.height
  );
});
//# sourceMappingURL=Clusterer.js.map